/**
 * Copyright (c) 2006-2012 EBM WebSourcing, 2012-2016 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.microkernel.api.jbi.management;

import java.net.MalformedURLException;

import javax.jbi.JBIException;
import javax.management.ObjectName;

import org.ow2.petals.microkernel.api.PetalsLifeCycle;
import org.ow2.petals.microkernel.api.container.Installer;

/**
 * @author Roland Naudin - EBM WebSourcing
 */
public interface InstallationService extends InstallationServiceMBean, PetalsLifeCycle {

    public static final String COMPONENT_LOGGER_NAME = "Petals.JBI-Management.InstallationService";

    /**
     * Like {@link #loadNewInstaller(String)} but used internally and returning the {@link Installer} object instead of
     * an {@link ObjectName}.
     */
    public Installer loadNewInstallerInternal(String installZipURL) throws JBIException, MalformedURLException;

    /**
     * Like {@link #loadInstaller(String)} but used internally and returning the {@link Installer} object instead of an
     * {@link ObjectName}.
     */
    public Installer LoadInstallerInternal(String componentName) throws JBIException;
}
